package fabbroniko.testrawvideofile.testextractor;

import android.content.Context;
import android.media.MediaDataSource;
import android.util.Log;

import java.io.IOException;
import java.io.InputStream;

import fabbroniko.testrawvideofile.R;

public class MyCustomSource extends MediaDataSource {

    private static final int BUFFER_DIMENSION = 65536;
    private static final int DIMENSION_UNDEFINED = -1;

    private byte[] tmp = new byte[BUFFER_DIMENSION];
    private InputStream inputStream;

    public MyCustomSource(final Context context) {
        super();
        inputStream = context.getResources().openRawResource(R.raw.sample_video);
    }

    @Override
    public int readAt(long position, byte[] buffer, int offset, int size) throws IOException {
        //Log.d("readAt", "Position: " + position + "Buffer: " buffer);
        //return inputStream.read(buffer, offset, size);
        //System.arraycopy(tmp, (int)position, buffer, offset, size);
        //return size;
        int numByteRead = inputStream.read(buffer, offset, size);

        return numByteRead;
    }

    @Override
    public long getSize() throws IOException {
        //Log.d("getSize", "Gettata dimensione.");
        return DIMENSION_UNDEFINED;
    }

    @Override
    public void close() throws IOException {

    }
}
